import { Stringifyr } from '@stringifyrjs/core';
import { TStringifyrParams } from '@stringifyrjs/core/src/Stringifyr';
import { CoreFileSlug } from '@stringifyrjs/core/src/Types-Injected';
import * as React from 'react';
import { PropsWithChildren } from 'react';
import { StringifyrRootProvider } from './StringifyrRootProvider';

export const StringifyrDefaultRootProvider = ({
  apiKey,
  fileSlug,
  batchMS,
  baseURL,
  includeUnpublished,
  defaults,
  storageId,
  storage,
  maxServerTimeMS,
  children,
}: PropsWithChildren<TStringifyrParams<CoreFileSlug>>) => {
  const sfyr = React.useMemo(() => {
    return Stringifyr({
      apiKey,
      fileSlug,
      batchMS,
      baseURL,
      includeUnpublished,
      defaults,
      storageId,
      storage,
      maxServerTimeMS,
    });
  }, [
    apiKey,
    fileSlug,
    batchMS,
    baseURL,
    includeUnpublished,
    defaults,
    storageId,
    storage,
    maxServerTimeMS,
  ]);

  return (
    // @ts-ignore // todo
    <StringifyrRootProvider sfyr={sfyr}>
      {children}
    </StringifyrRootProvider>
  );
};
