import { type TStringifyr } from '@stringifyrjs/core/src/Stringifyr';
import * as React from 'react';
import { FetchBoundaryContext } from './StringifyrFetchBoundary';
import { StringifyrRootContext } from './StringifyrRootProvider';

export function useStringifyr() {
  const root = React.useContext(StringifyrRootContext);
  const parent = React.useContext(FetchBoundaryContext);
  const closestSfyrBoundary = parent.sfyr ?? root.sfyr;

  if (!closestSfyrBoundary) {
    throw new Error([
      'useStringifyr',
      `Not in a Stringifyr context, you most likely forgot to add <StringifyrRootProvider /> to the root of your app.`,
    ].join(', '));
  }

  return closestSfyrBoundary as any as TStringifyr;
}
